import React__default from 'react';
import ChannelSettingsUI from './ChannelSettings/components/ChannelSettingsUI.js';
import { ChannelSettingsProvider } from './ChannelSettings/context.js';
import './chunks/bundle-DQAyPA9h.js';
import './useSendbirdStateContext.js';
import './withSendbird.js';
import './ChannelSettings/components/ChannelSettingsHeader.js';
import './chunks/bundle-C5TxIjYS.js';
import './chunks/bundle-CP8IZx6k.js';
import './chunks/bundle-CtoEZBYL.js';
import './ui/Icon.js';
import './chunks/bundle-B0JJXfcN.js';
import './ui/Header.js';
import './chunks/bundle-BKTUa7Hh.js';
import './chunks/bundle-BaYDB95w.js';
import './ui/TextButton.js';
import './chunks/bundle-BN6KrkVC.js';
import './ui/IconButton.js';
import './ui/PlaceHolder.js';
import './ui/Loader.js';
import './ChannelSettings/components/ChannelProfile.js';
import './ui/ChannelAvatar.js';
import './chunks/bundle-BgqXw7TW.js';
import './ui/ImageRenderer.js';
import './chunks/bundle-BamawVRC.js';
import './chunks/bundle-BF5pm41Z.js';
import './ChannelSettings/components/EditDetailsModal.js';
import './chunks/bundle-Drx9_pPb.js';
import './chunks/bundle-CQkS3BVo.js';
import '@sendbird/chat/groupChannel';
import './utils/message/getOutgoingMessageState.js';
import 'react-dom';
import './ui/Button.js';
import '@sendbird/uikit-tools';
import 'css-vars-ponyfill';
import '@sendbird/chat';
import './chunks/bundle-D_B-XPiX.js';
import '@sendbird/chat/openChannel';
import './chunks/bundle-D9HPnnfT.js';
import './chunks/bundle-D08cpCPN.js';
import './chunks/bundle-CJ6qEjG7.js';
import './ui/Input.js';
import './ChannelSettings/components/ModerationPanel.js';
import './ui/Accordion.js';
import './ui/AccordionGroup.js';
import './ui/Badge.js';
import './ui/Toggle.js';
import './ui/ContextMenu.js';
import './ui/SortByRow.js';
import './ChannelSettings/components/UserListItem.js';
import './chunks/bundle-zderVHCt.js';
import './ui/MutedAvatarOverlay.js';
import './ui/UserProfile.js';
import './sendbirdSelectors.js';
import './chunks/bundle-CJM4fAMC.js';
import './ui/UserListItem.js';
import './ui/Checkbox.js';
import './chunks/bundle-DCwEebhZ.js';
import './chunks/bundle-COIwriEM.js';
import '@sendbird/chat/message';
import './chunks/bundle-Ci9SzdkN.js';
import './chunks/bundle-IrSSguGA.js';
import './ChannelSettings/components/LeaveChannel.js';
import './ChannelSettings/components/UserPanel.js';

var ChannelSettings = function (props) {
    return (React__default.createElement(ChannelSettingsProvider, { overrideInviteUser: props === null || props === void 0 ? void 0 : props.overrideInviteUser, channelUrl: props.channelUrl, onCloseClick: props === null || props === void 0 ? void 0 : props.onCloseClick, onLeaveChannel: props === null || props === void 0 ? void 0 : props.onLeaveChannel, onChannelModified: props === null || props === void 0 ? void 0 : props.onChannelModified, onBeforeUpdateChannel: props === null || props === void 0 ? void 0 : props.onBeforeUpdateChannel, queries: props === null || props === void 0 ? void 0 : props.queries, className: props === null || props === void 0 ? void 0 : props.className, disableUserProfile: props === null || props === void 0 ? void 0 : props.disableUserProfile, renderUserProfile: props === null || props === void 0 ? void 0 : props.renderUserProfile },
        React__default.createElement(ChannelSettingsUI, { renderPlaceholderError: props === null || props === void 0 ? void 0 : props.renderPlaceholderError, renderChannelProfile: props === null || props === void 0 ? void 0 : props.renderChannelProfile, renderModerationPanel: props === null || props === void 0 ? void 0 : props.renderModerationPanel, renderLeaveChannel: props === null || props === void 0 ? void 0 : props.renderLeaveChannel })));
};

export { ChannelSettings as default };
//# sourceMappingURL=ChannelSettings.js.map
