import { _ as __assign } from './chunks/bundle-DQAyPA9h.js';
import React__default from 'react';
import { GroupChannelProvider } from './GroupChannel/context.js';
import { GroupChannelUI } from './GroupChannel/components/GroupChannelUI.js';
import '@sendbird/chat/message';
import '@sendbird/chat/groupChannel';
import '@sendbird/uikit-tools';
import './chunks/bundle-zderVHCt.js';
import './useSendbirdStateContext.js';
import './withSendbird.js';
import './chunks/bundle-CU2znKqJ.js';
import './chunks/bundle-SXVoVAjh.js';
import './chunks/bundle-C__wmlYg.js';
import './chunks/bundle-DCwEebhZ.js';
import './chunks/bundle-D08cpCPN.js';
import './chunks/bundle-COIwriEM.js';
import './chunks/bundle-Ci9SzdkN.js';
import './chunks/bundle-D66QKU9Q.js';
import './chunks/bundle-CJM4fAMC.js';
import './chunks/bundle-CPPzZJz_.js';
import './chunks/bundle-xnilPNvq.js';
import './GroupChannel/components/TypingIndicator.js';
import './chunks/bundle-BKTUa7Hh.js';
import './chunks/bundle-CP8IZx6k.js';
import './chunks/bundle-C5TxIjYS.js';
import './chunks/bundle-CtoEZBYL.js';
import './chunks/bundle-D_B-XPiX.js';
import './chunks/bundle-CQkS3BVo.js';
import './utils/message/getOutgoingMessageState.js';
import './ui/ConnectionStatus.js';
import './ui/Icon.js';
import './chunks/bundle-B0JJXfcN.js';
import './ui/PlaceHolder.js';
import './ui/Loader.js';
import './GroupChannel/components/GroupChannelHeader.js';
import './chunks/bundle-Dam3o08s.js';
import './ui/ChannelAvatar.js';
import './chunks/bundle-BgqXw7TW.js';
import './ui/ImageRenderer.js';
import './chunks/bundle-BamawVRC.js';
import './chunks/bundle-BF5pm41Z.js';
import './chunks/bundle-v5KZKQck.js';
import './chunks/bundle-BaYDB95w.js';
import './ui/Header.js';
import './ui/TextButton.js';
import './chunks/bundle-BN6KrkVC.js';
import './ui/IconButton.js';
import './GroupChannel/components/MessageList.js';
import './GroupChannel/components/Message.js';
import './chunks/bundle-Cu3w1i4p.js';
import './chunks/bundle-Cs_QRAMA.js';
import './chunks/bundle-B5iwLbFn.js';
import './Message/hooks/useDirtyGetMentions.js';
import './ui/DateSeparator.js';
import './ui/MessageInput.js';
import './chunks/bundle-ap3nGOTC.js';
import './ui/Button.js';
import './chunks/bundle-DaikZZYx.js';
import 'dompurify';
import './chunks/bundle-CnH5RpMk.js';
import './chunks/bundle-DHeiVDhy.js';
import './chunks/bundle-Bi2LuZyZ.js';
import './chunks/bundle-BvpR258i.js';
import './ui/MessageContent.js';
import './chunks/bundle-DjrQXf-q.js';
import './chunks/bundle-CqDjIUvM.js';
import './chunks/bundle-Cg9g6249.js';
import './ui/MessageItemMenu.js';
import './ui/ContextMenu.js';
import './chunks/bundle-CJ6qEjG7.js';
import 'react-dom';
import '@sendbird/chat';
import '@sendbird/chat/openChannel';
import './ui/SortByRow.js';
import './chunks/bundle-DgABXydG.js';
import './ui/MessageItemReactionMenu.js';
import './ui/ReactionButton.js';
import './chunks/bundle-D4aRJBSh.js';
import './ui/EmojiReactions.js';
import './ui/ReactionBadge.js';
import './ui/BottomSheet.js';
import './chunks/bundle-Drx9_pPb.js';
import 'css-vars-ponyfill';
import './chunks/bundle-D9HPnnfT.js';
import './ui/UserListItem.js';
import './ui/MutedAvatarOverlay.js';
import './ui/Checkbox.js';
import './ui/UserProfile.js';
import './sendbirdSelectors.js';
import './ui/Tooltip.js';
import './ui/TooltipWrapper.js';
import './Message/context.js';
import './ui/AdminMessage.js';
import './ui/QuoteMessage.js';
import './chunks/bundle-Drh7i9j0.js';
import './chunks/bundle-uN9TaIwQ.js';
import './ui/ThreadReplies.js';
import './ui/OGMessageItemBody.js';
import './chunks/bundle-CyKPILZ3.js';
import './ui/MentionLabel.js';
import './ui/LinkLabel.js';
import './ui/TextMessageItemBody.js';
import './ui/FileMessageItemBody.js';
import './chunks/bundle-CTGBGjol.js';
import './chunks/bundle-sTI1sL6J.js';
import './chunks/bundle-C8p1vKGT.js';
import './ui/VoiceMessageItemBody.js';
import './ui/ProgressBar.js';
import './VoicePlayer/useVoicePlayer.js';
import './ui/PlaybackTime.js';
import './ui/ThumbnailMessageItemBody.js';
import './ui/UnknownMessageItemBody.js';
import './ui/TemplateMessageItemBody.js';
import './chunks/bundle-D3K62z2v.js';
import './ui/FallbackTemplateMessageItemBody.tsx.js';
import './ui/LoadingTemplateMessageItemBody.tsx.js';
import './ui/FeedbackIconButton.js';
import './ui/MobileFeedbackMenu.js';
import './ui/MessageFeedbackModal.js';
import './ui/Input.js';
import './ui/MessageFeedbackFailedModal.js';
import './GroupChannel/components/SuggestedReplies.js';
import './chunks/bundle-EafsND-Z.js';
import './GroupChannel/components/FileViewer.js';
import './chunks/bundle-CaT7U7oh.js';
import './GroupChannel/components/RemoveMessageModal.js';
import './chunks/bundle-BhhGGFEj.js';
import './chunks/bundle-DuOrTDlQ.js';
import './Channel/utils/getMessagePartsInfo.js';
import './Channel/utils/compareMessagesForGrouping.js';
import './GroupChannel/components/UnreadCount.js';
import './GroupChannel/components/FrozenNotification.js';
import './ui/TypingIndicatorBubble.js';
import './GroupChannel/components/MessageInputWrapper.js';
import './chunks/bundle-DJdyvJml.js';
import './GroupChannel/components/SuggestedMentionList.js';
import './ui/QuoteMessageInput.js';
import './VoiceRecorder/useVoiceRecorder.js';
import './chunks/bundle-C8ONjjf7.js';
import './chunks/bundle-B60tMN4Q.js';

var GroupChannel = function (props) {
    return (React__default.createElement(GroupChannelProvider, __assign({}, props),
        React__default.createElement(GroupChannelUI, __assign({}, props))));
};

export { GroupChannel, GroupChannel as default };
//# sourceMappingURL=GroupChannel.js.map
