import { _ as __assign, a as __awaiter, b as __generator } from '../../chunks/bundle-DQAyPA9h.js';
import React__default from 'react';
import { F as FileViewerView } from '../../chunks/bundle-CaT7U7oh.js';
import { useGroupChannelContext } from '../context.js';
import { useSendbirdStateContext } from '../../useSendbirdStateContext.js';
import 'react-dom';
import '../../chunks/bundle-BgqXw7TW.js';
import '../../ui/ImageRenderer.js';
import '../../chunks/bundle-B0JJXfcN.js';
import '../../chunks/bundle-BamawVRC.js';
import '../../ui/Icon.js';
import '../../chunks/bundle-BKTUa7Hh.js';
import '../../chunks/bundle-CP8IZx6k.js';
import '../../chunks/bundle-CQkS3BVo.js';
import '@sendbird/chat/groupChannel';
import '../../utils/message/getOutgoingMessageState.js';
import '../../chunks/bundle-Drx9_pPb.js';
import '../../chunks/bundle-C5TxIjYS.js';
import '../../chunks/bundle-CtoEZBYL.js';
import '../../chunks/bundle-BaYDB95w.js';
import '../../ui/IconButton.js';
import '../../ui/Button.js';
import '@sendbird/uikit-tools';
import '../../withSendbird.js';
import 'css-vars-ponyfill';
import '@sendbird/chat';
import '../../chunks/bundle-D_B-XPiX.js';
import '@sendbird/chat/openChannel';
import '../../chunks/bundle-D9HPnnfT.js';
import '../../chunks/bundle-D08cpCPN.js';
import '../../chunks/bundle-CJ6qEjG7.js';
import '@sendbird/chat/message';
import '../../chunks/bundle-zderVHCt.js';
import '../../chunks/bundle-CU2znKqJ.js';
import '../../chunks/bundle-SXVoVAjh.js';
import '../../chunks/bundle-C__wmlYg.js';
import '../../chunks/bundle-DCwEebhZ.js';
import '../../chunks/bundle-COIwriEM.js';
import '../../chunks/bundle-Ci9SzdkN.js';
import '../../chunks/bundle-D66QKU9Q.js';
import '../../chunks/bundle-CJM4fAMC.js';
import '../../chunks/bundle-CPPzZJz_.js';

var FileViewer = function (props) {
    var _a = useGroupChannelContext(), deleteMessage = _a.deleteMessage, onBeforeDownloadFileMessage = _a.onBeforeDownloadFileMessage;
    var config = useSendbirdStateContext().config;
    var logger = config.logger;
    return (React__default.createElement(FileViewerView, __assign({}, props, { deleteMessage: deleteMessage, onDownloadClick: function (e) { return __awaiter(void 0, void 0, void 0, function () {
            var allowDownload, err_1;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!onBeforeDownloadFileMessage)
                            return [2 /*return*/];
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, onBeforeDownloadFileMessage({ message: props.message })];
                    case 2:
                        allowDownload = _c.sent();
                        if (!allowDownload) {
                            e.preventDefault();
                            (_a = logger.info) === null || _a === void 0 ? void 0 : _a.call(logger, 'FileViewer: Not allowed to download.');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _c.sent();
                        (_b = logger.error) === null || _b === void 0 ? void 0 : _b.call(logger, 'FileViewer: Error occurred while determining download continuation:', err_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); } })));
};

export { FileViewer, FileViewer as default };
//# sourceMappingURL=FileViewer.js.map
