import { _ as __assign } from '../../chunks/bundle-DQAyPA9h.js';
import React__default from 'react';
import { M as MessageInputWrapperView } from '../../chunks/bundle-DJdyvJml.js';
export { V as VoiceMessageInputWrapper } from '../../chunks/bundle-DJdyvJml.js';
import { useGroupChannelContext } from '../context.js';
import { useIIFE } from '@sendbird/uikit-tools';
import { g as getSuggestedReplies, e as isSendableMessage } from '../../chunks/bundle-CQkS3BVo.js';
import { useSendbirdStateContext } from '../../useSendbirdStateContext.js';
import '../../chunks/bundle-C__wmlYg.js';
import '../../chunks/bundle-C5TxIjYS.js';
import '../../chunks/bundle-CP8IZx6k.js';
import '../../chunks/bundle-CtoEZBYL.js';
import './SuggestedMentionList.js';
import '../../chunks/bundle-EafsND-Z.js';
import '../../chunks/bundle-BKTUa7Hh.js';
import '../../ui/Icon.js';
import '../../chunks/bundle-B0JJXfcN.js';
import '../../chunks/bundle-BgqXw7TW.js';
import '../../ui/ImageRenderer.js';
import '../../chunks/bundle-BamawVRC.js';
import '../../chunks/bundle-D_B-XPiX.js';
import '../../chunks/bundle-B5iwLbFn.js';
import '../../chunks/bundle-ap3nGOTC.js';
import '../../withSendbird.js';
import '../../Message/hooks/useDirtyGetMentions.js';
import '../../ui/QuoteMessageInput.js';
import '../../chunks/bundle-Drh7i9j0.js';
import '../../VoicePlayer/useVoicePlayer.js';
import '../../chunks/bundle-D9HPnnfT.js';
import '../../chunks/bundle-D08cpCPN.js';
import '../../chunks/bundle-Drx9_pPb.js';
import 'react-dom';
import '../../chunks/bundle-BaYDB95w.js';
import '../../ui/IconButton.js';
import '../../ui/Button.js';
import 'css-vars-ponyfill';
import '@sendbird/chat';
import '@sendbird/chat/openChannel';
import '@sendbird/chat/groupChannel';
import '../../chunks/bundle-CJ6qEjG7.js';
import '../../VoiceRecorder/useVoiceRecorder.js';
import '../../chunks/bundle-C8ONjjf7.js';
import '../../ui/PlaybackTime.js';
import '../../ui/ProgressBar.js';
import '../../ui/TextButton.js';
import '../../chunks/bundle-BN6KrkVC.js';
import '../../ui/MessageInput.js';
import '../../chunks/bundle-DaikZZYx.js';
import 'dompurify';
import '../../chunks/bundle-CnH5RpMk.js';
import '../../chunks/bundle-DHeiVDhy.js';
import '../../chunks/bundle-Bi2LuZyZ.js';
import '../../chunks/bundle-BvpR258i.js';
import '../../chunks/bundle-B60tMN4Q.js';
import '@sendbird/chat/message';
import '../../chunks/bundle-zderVHCt.js';
import '../../chunks/bundle-CU2znKqJ.js';
import '../../chunks/bundle-SXVoVAjh.js';
import '../../chunks/bundle-DCwEebhZ.js';
import '../../chunks/bundle-COIwriEM.js';
import '../../chunks/bundle-Ci9SzdkN.js';
import '../../chunks/bundle-D66QKU9Q.js';
import '../../chunks/bundle-CJM4fAMC.js';
import '../../chunks/bundle-CPPzZJz_.js';
import '../../utils/message/getOutgoingMessageState.js';

var MessageInputWrapper = function (props) {
    var _a;
    var config = useSendbirdStateContext().config;
    var context = useGroupChannelContext();
    var messages = context.messages, currentChannel = context.currentChannel;
    var lastMessage = currentChannel === null || currentChannel === void 0 ? void 0 : currentChannel.lastMessage;
    var isLastMessageSuggestedRepliesEnabled = useIIFE(function () {
        var _a;
        if (!((_a = config === null || config === void 0 ? void 0 : config.groupChannel) === null || _a === void 0 ? void 0 : _a.enableSuggestedReplies))
            return false;
        if (getSuggestedReplies(lastMessage !== null && lastMessage !== void 0 ? lastMessage : undefined).length === 0)
            return false;
        var lastMessageInContext = messages[messages.length - 1];
        if (isSendableMessage(lastMessageInContext) && lastMessageInContext.sendingStatus !== 'succeeded')
            return false;
        return true;
    });
    var disableMessageInput = props.disabled
        || isLastMessageSuggestedRepliesEnabled && !!((_a = lastMessage === null || lastMessage === void 0 ? void 0 : lastMessage.extendedMessagePayload) === null || _a === void 0 ? void 0 : _a['disable_chat_input']);
    return (React__default.createElement(MessageInputWrapperView, __assign({}, props, context, { disabled: disableMessageInput })));
};

export { MessageInputWrapper, MessageInputWrapper as default };
//# sourceMappingURL=MessageInputWrapper.js.map
