import React__default from 'react';
import { ThreadProvider } from './Thread/context.js';
import ThreadUI from './Thread/components/ThreadUI.js';
import './chunks/bundle-BYR4olNi.js';
import './chunks/bundle-CJM4fAMC.js';
import './chunks/bundle-COIwriEM.js';
import './chunks/bundle-DQAyPA9h.js';
import '@sendbird/chat/message';
import './utils/message/getOutgoingMessageState.js';
import './chunks/bundle-D08cpCPN.js';
import './chunks/bundle-zderVHCt.js';
import './useSendbirdStateContext.js';
import './withSendbird.js';
import './Thread/context/types.js';
import '@sendbird/chat';
import './chunks/bundle-GdMXc-ey.js';
import '@sendbird/chat/groupChannel';
import './chunks/bundle-D_B-XPiX.js';
import './chunks/bundle-DUHH_9vE.js';
import './chunks/bundle-C5TxIjYS.js';
import './chunks/bundle-CP8IZx6k.js';
import './chunks/bundle-CtoEZBYL.js';
import './chunks/bundle-v5KZKQck.js';
import './chunks/bundle-BKTUa7Hh.js';
import './Thread/components/ParentMessageInfo.js';
import './chunks/bundle-Cs_QRAMA.js';
import './chunks/bundle-5te6AJ6n.js';
import './chunks/bundle-Drx9_pPb.js';
import './chunks/bundle-CQkS3BVo.js';
import './chunks/bundle-B0JJXfcN.js';
import 'react-dom';
import './chunks/bundle-BaYDB95w.js';
import './ui/IconButton.js';
import './ui/Button.js';
import './ui/Icon.js';
import '@sendbird/uikit-tools';
import 'css-vars-ponyfill';
import '@sendbird/chat/openChannel';
import './chunks/bundle-D9HPnnfT.js';
import './chunks/bundle-CJ6qEjG7.js';
import './chunks/bundle-DuOrTDlQ.js';
import './Thread/components/ParentMessageInfoItem.js';
import './ui/ImageRenderer.js';
import './ui/TextButton.js';
import './chunks/bundle-BN6KrkVC.js';
import './ui/EmojiReactions.js';
import './ui/ReactionBadge.js';
import './ui/ReactionButton.js';
import './chunks/bundle-D4aRJBSh.js';
import './ui/ContextMenu.js';
import './ui/SortByRow.js';
import './ui/BottomSheet.js';
import './ui/UserListItem.js';
import './chunks/bundle-BgqXw7TW.js';
import './chunks/bundle-BamawVRC.js';
import './ui/MutedAvatarOverlay.js';
import './ui/Checkbox.js';
import './ui/UserProfile.js';
import './sendbirdSelectors.js';
import './ui/Tooltip.js';
import './ui/TooltipWrapper.js';
import './Message/context.js';
import './chunks/bundle-CPPzZJz_.js';
import './ui/VoiceMessageItemBody.js';
import './ui/ProgressBar.js';
import './VoicePlayer/useVoicePlayer.js';
import './ui/PlaybackTime.js';
import './ui/Loader.js';
import './chunks/bundle-CyKPILZ3.js';
import './chunks/bundle-BvpR258i.js';
import './ui/MentionLabel.js';
import './ui/LinkLabel.js';
import './chunks/bundle-CTGBGjol.js';
import './chunks/bundle-sTI1sL6J.js';
import './chunks/bundle-C8p1vKGT.js';
import './chunks/bundle-C6ORm1KQ.js';
import './chunks/bundle-EafsND-Z.js';
import './chunks/bundle-B5iwLbFn.js';
import './chunks/bundle-ap3nGOTC.js';
import './ui/MessageItemMenu.js';
import './chunks/bundle-DgABXydG.js';
import './ui/MessageItemReactionMenu.js';
import './ui/MessageInput.js';
import './chunks/bundle-DaikZZYx.js';
import 'dompurify';
import './chunks/bundle-CnH5RpMk.js';
import './chunks/bundle-DHeiVDhy.js';
import './chunks/bundle-Bi2LuZyZ.js';
import './chunks/bundle-uN9TaIwQ.js';
import './Message/hooks/useDirtyGetMentions.js';
import './chunks/bundle-SXVoVAjh.js';
import './Thread/components/ThreadHeader.js';
import './ui/Header.js';
import './Thread/components/ThreadList.js';
import './Thread/components/ThreadListItem.js';
import './ui/DateSeparator.js';
import './chunks/bundle-DjrQXf-q.js';
import './chunks/bundle-CqDjIUvM.js';
import './chunks/bundle-Cg9g6249.js';
import './ui/TextMessageItemBody.js';
import './ui/OGMessageItemBody.js';
import './ui/FileMessageItemBody.js';
import './ui/ThumbnailMessageItemBody.js';
import './chunks/bundle-Drh7i9j0.js';
import './ui/UnknownMessageItemBody.js';
import './Channel/utils/compareMessagesForGrouping.js';
import 'date-fns';
import './Thread/components/ThreadMessageInput.js';
import './chunks/bundle-DJdyvJml.js';
import './chunks/bundle-C__wmlYg.js';
import './GroupChannel/components/SuggestedMentionList.js';
import './ui/QuoteMessageInput.js';
import './VoiceRecorder/useVoiceRecorder.js';
import './chunks/bundle-C8ONjjf7.js';
import './chunks/bundle-B60tMN4Q.js';
import './GroupChannel/context.js';
import './chunks/bundle-CU2znKqJ.js';
import './chunks/bundle-DCwEebhZ.js';
import './chunks/bundle-Ci9SzdkN.js';
import './chunks/bundle-D66QKU9Q.js';
import './Channel/hooks/useHandleUploadFiles.js';
import './ui/PlaceHolder.js';

var Thread = function (props) {
    var 
    // props
    className = props.className, 
    // ThreadProviderProps
    channelUrl = props.channelUrl, message = props.message, onHeaderActionClick = props.onHeaderActionClick, onMoveToParentMessage = props.onMoveToParentMessage, isMultipleFilesMessageEnabled = props.isMultipleFilesMessageEnabled, 
    // onBeforeSend~~~Message
    onBeforeSendUserMessage = props.onBeforeSendUserMessage, onBeforeSendFileMessage = props.onBeforeSendFileMessage, onBeforeSendVoiceMessage = props.onBeforeSendVoiceMessage, onBeforeSendMultipleFilesMessage = props.onBeforeSendMultipleFilesMessage, 
    // ThreadUIProps
    renderHeader = props.renderHeader, renderParentMessageInfo = props.renderParentMessageInfo, renderMessage = props.renderMessage, renderMessageInput = props.renderMessageInput, renderCustomSeparator = props.renderCustomSeparator, renderParentMessageInfoPlaceholder = props.renderParentMessageInfoPlaceholder, renderThreadListPlaceHolder = props.renderThreadListPlaceHolder, renderFileUploadIcon = props.renderFileUploadIcon, renderVoiceMessageIcon = props.renderVoiceMessageIcon, renderSendMessageIcon = props.renderSendMessageIcon;
    return (React__default.createElement("div", { className: "sendbird-thread ".concat(className) },
        React__default.createElement(ThreadProvider, { channelUrl: channelUrl, message: message, onHeaderActionClick: onHeaderActionClick, onMoveToParentMessage: onMoveToParentMessage, onBeforeSendUserMessage: onBeforeSendUserMessage, onBeforeSendFileMessage: onBeforeSendFileMessage, onBeforeSendVoiceMessage: onBeforeSendVoiceMessage, onBeforeSendMultipleFilesMessage: onBeforeSendMultipleFilesMessage, isMultipleFilesMessageEnabled: isMultipleFilesMessageEnabled },
            React__default.createElement(ThreadUI, { renderHeader: renderHeader, renderParentMessageInfo: renderParentMessageInfo, renderMessage: renderMessage, renderMessageInput: renderMessageInput, renderCustomSeparator: renderCustomSeparator, renderParentMessageInfoPlaceholder: renderParentMessageInfoPlaceholder, renderThreadListPlaceHolder: renderThreadListPlaceHolder, renderFileUploadIcon: renderFileUploadIcon, renderVoiceMessageIcon: renderVoiceMessageIcon, renderSendMessageIcon: renderSendMessageIcon }))));
};

export { Thread as default };
//# sourceMappingURL=Thread.js.map
