import React__default, { useState, useContext, useEffect, useCallback } from 'react';
import Button, { ButtonTypes, ButtonSizes } from '../ui/Button.js';
import IconButton from '../ui/IconButton.js';
import Icon, { IconTypes, IconColors } from '../ui/Icon.js';
import ContextMenu, { MenuItems, OperatorMenuItem, MuteMenuItem, MenuItem } from '../ui/ContextMenu.js';
import UserListItem$1 from '../ChannelSettings/components/UserListItem.js';
import { c as __spreadArray, a as __awaiter, b as __generator } from './bundle-DQAyPA9h.js';
import { Role } from '@sendbird/chat';
import { M as Modal } from './bundle-Drx9_pPb.js';
import UserListItem from '../ui/UserListItem.js';
import { n as noop } from './bundle-B0JJXfcN.js';
import { useChannelSettingsContext } from '../ChannelSettings/context.js';
import { useSendbirdStateContext } from '../useSendbirdStateContext.js';
import { L as LocalizationContext } from './bundle-C5TxIjYS.js';
import { u as useOnScrollPositionChangeDetector } from './bundle-DCwEebhZ.js';
import { u as uuidv4 } from './bundle-D_B-XPiX.js';

function MembersModal(_a) {
    var _this = this;
    var _b;
    var onCancel = _a.onCancel;
    var _c = useState([]), members = _c[0], setMembers = _c[1];
    var _d = useState(null), memberQuery = _d[0], setMemberQuery = _d[1];
    var channel = useChannelSettingsContext().channel;
    var state = useSendbirdStateContext();
    var currentUserId = (_b = state === null || state === void 0 ? void 0 : state.config) === null || _b === void 0 ? void 0 : _b.userId;
    var stringSet = useContext(LocalizationContext).stringSet;
    useEffect(function () {
        var memberListQuery = channel === null || channel === void 0 ? void 0 : channel.createMemberListQuery({
            limit: 20,
        });
        memberListQuery === null || memberListQuery === void 0 ? void 0 : memberListQuery.next().then(function (members) {
            setMembers(members);
        });
        setMemberQuery(memberListQuery !== null && memberListQuery !== void 0 ? memberListQuery : null);
    }, []);
    return (React__default.createElement("div", null,
        React__default.createElement(Modal, { isFullScreenOnMobile: true, hideFooter: true, onCancel: function () { return onCancel(); }, onSubmit: noop, titleText: stringSet.CHANNEL_SETTING__MEMBERS__SEE_ALL_MEMBERS },
            React__default.createElement("div", { className: "sendbird-more-members__popup-scroll", onScroll: useOnScrollPositionChangeDetector({
                    onReachedBottom: function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            if (memberQuery && memberQuery.hasNext) {
                                memberQuery.next().then(function (o) {
                                    setMembers(__spreadArray(__spreadArray([], members, true), o, true));
                                });
                            }
                            return [2 /*return*/];
                        });
                    }); },
                }) }, members.map(function (member) {
                return (React__default.createElement(UserListItem, { user: member, key: member.userId, currentUser: currentUserId, action: function (_a) {
                        var parentRef = _a.parentRef, actionRef = _a.actionRef;
                        return (React__default.createElement(React__default.Fragment, null, (channel === null || channel === void 0 ? void 0 : channel.myRole) === 'operator' && currentUserId !== member.userId && (React__default.createElement(ContextMenu, { menuTrigger: function (toggleDropdown) { return (React__default.createElement(IconButton, { className: "sendbird-user-message__more__menu", width: "32px", height: "32px", onClick: function () {
                                    toggleDropdown();
                                } },
                                React__default.createElement(Icon, { width: "24px", height: "24px", type: IconTypes.MORE, fillColor: IconColors.CONTENT_INVERSE }))); }, menuItems: function (closeDropdown) { return (React__default.createElement(MenuItems, { parentContainRef: parentRef, parentRef: actionRef, closeDropdown: closeDropdown, openLeft: true },
                                React__default.createElement(OperatorMenuItem, { channel: channel, user: member, disable: currentUserId === member.userId, onChange: function (_, member, isOperator) {
                                        var newMembers = __spreadArray([], members, true);
                                        for (var _i = 0, newMembers_1 = newMembers; _i < newMembers_1.length; _i++) {
                                            var newMember = newMembers_1[_i];
                                            if (newMember.userId === member.userId) {
                                                newMember.role = isOperator ? Role.OPERATOR : Role.NONE;
                                            }
                                        }
                                        setMembers(newMembers);
                                        closeDropdown();
                                    }, onError: function () {
                                        // FIXME: handle error later
                                        closeDropdown();
                                    }, dataSbId: "channel_setting_member_context_menu_".concat((member.role !== 'operator') ? 'register_as_operator' : 'unregister_operator') }, member.role !== 'operator'
                                    ? stringSet.CHANNEL_SETTING__MODERATION__REGISTER_AS_OPERATOR
                                    : stringSet.CHANNEL_SETTING__MODERATION__UNREGISTER_OPERATOR),
                                // No muted members in broadcast channel
                                !(channel === null || channel === void 0 ? void 0 : channel.isBroadcast) && (React__default.createElement(MuteMenuItem, { channel: channel, user: member, onChange: function (_, member, isMuted) {
                                        var newMembers = __spreadArray([], members, true);
                                        for (var _i = 0, newMembers_2 = newMembers; _i < newMembers_2.length; _i++) {
                                            var newMember = newMembers_2[_i];
                                            if (newMember.userId === member.userId) {
                                                newMember.isMuted = isMuted;
                                            }
                                        }
                                        setMembers(newMembers);
                                        closeDropdown();
                                    }, onError: function () {
                                        // FIXME: handle error later
                                        closeDropdown();
                                    }, dataSbId: "channel_setting_member_context_menu_".concat((member.isMuted) ? 'unmute' : 'mute') }, member.isMuted
                                    ? stringSet.CHANNEL_SETTING__MODERATION__UNMUTE
                                    : stringSet.CHANNEL_SETTING__MODERATION__MUTE)),
                                React__default.createElement(MenuItem, { onClick: function () {
                                        channel === null || channel === void 0 ? void 0 : channel.banUser(member, -1, '').then(function () {
                                            setMembers(members.filter(function (_a) {
                                                var userId = _a.userId;
                                                return userId !== member.userId;
                                            }));
                                        });
                                    }, dataSbId: "channel_setting_member_context_menu_ban" }, stringSet.CHANNEL_SETTING__MODERATION__BAN))); } }))));
                    } }));
            })))));
}

var MemberList = function () {
    var _a, _b, _c;
    var _d = useState([]), members = _d[0], setMembers = _d[1];
    var _e = useState(false), hasNext = _e[0], setHasNext = _e[1];
    var _f = useState(false), showAllMembers = _f[0], setShowAllMembers = _f[1];
    var _g = useState(false); _g[0]; _g[1];
    var state = useSendbirdStateContext();
    var _h = useChannelSettingsContext(), channel = _h.channel, setChannelUpdateId = _h.setChannelUpdateId;
    var stringSet = useContext(LocalizationContext).stringSet;
    var sdk = (_b = (_a = state === null || state === void 0 ? void 0 : state.stores) === null || _a === void 0 ? void 0 : _a.sdkStore) === null || _b === void 0 ? void 0 : _b.sdk;
    var userId = (_c = state === null || state === void 0 ? void 0 : state.config) === null || _c === void 0 ? void 0 : _c.userId;
    useEffect(function () {
        if (!channel) {
            setMembers([]);
            return;
        }
        var memberUserListQuery = channel === null || channel === void 0 ? void 0 : channel.createMemberListQuery({ limit: 10 });
        memberUserListQuery.next().then(function (members) {
            setMembers(members);
            setHasNext(memberUserListQuery.hasNext);
        });
    }, [channel]);
    var refreshList = useCallback(function () {
        if (!channel) {
            setMembers([]);
            return;
        }
        var memberUserListQuery = channel === null || channel === void 0 ? void 0 : channel.createMemberListQuery({ limit: 10 });
        memberUserListQuery.next().then(function (members) {
            setMembers(members);
            setHasNext(memberUserListQuery.hasNext);
            setChannelUpdateId === null || setChannelUpdateId === void 0 ? void 0 : setChannelUpdateId(uuidv4());
        });
    }, [channel]);
    useEffect(function () {
        window.addEventListener('sendbird.refreshMemberList', refreshList);
        return function () {
            window.removeEventListener('sendbird.refreshMemberList', refreshList);
        };
    });
    return (React__default.createElement("div", { className: "sendbird-channel-settings-member-list sendbird-accordion" },
        members.map(function (member) { return (React__default.createElement(UserListItem$1, { key: member.userId, user: member, currentUser: sdk.currentUser.userId, action: ((channel === null || channel === void 0 ? void 0 : channel.myRole) === 'operator' && userId !== member.userId)
                ? function (_a) {
                    var actionRef = _a.actionRef, parentRef = _a.parentRef;
                    return (React__default.createElement(ContextMenu, { menuTrigger: function (toggleDropdown) { return (React__default.createElement(IconButton, { className: "sendbird-user-message__more__menu", width: "32px", height: "32px", onClick: toggleDropdown },
                            React__default.createElement(Icon, { width: "24px", height: "24px", type: IconTypes.MORE, fillColor: IconColors.CONTENT_INVERSE }))); }, menuItems: function (closeDropdown) { return (React__default.createElement(MenuItems, { parentContainRef: parentRef, parentRef: actionRef, closeDropdown: closeDropdown, openLeft: true },
                            React__default.createElement(OperatorMenuItem, { channel: channel, user: member, onChange: function () {
                                    refreshList();
                                    closeDropdown();
                                }, onError: noop, dataSbId: "channel_setting_member_context_menu_".concat((member.role !== 'operator') ? 'register_as_operator' : 'unregister_operator') }, member.role !== 'operator'
                                ? stringSet.CHANNEL_SETTING__MODERATION__REGISTER_AS_OPERATOR
                                : stringSet.CHANNEL_SETTING__MODERATION__UNREGISTER_OPERATOR),
                            // No muted members in broadcast channel
                            // Also can't mute in a one-to-one
                            !(channel === null || channel === void 0 ? void 0 : channel.isBroadcast) && (channel === null || channel === void 0 ? void 0 : channel.memberCount) > 2 && (React__default.createElement(MuteMenuItem, { channel: channel, user: member, onChange: function () {
                                    refreshList();
                                    closeDropdown();
                                }, onError: noop, dataSbId: "channel_setting_member_context_menu_".concat(member.isMuted ? 'unmute' : 'mute') }, member.isMuted
                                ? stringSet.CHANNEL_SETTING__MODERATION__UNMUTE
                                : stringSet.CHANNEL_SETTING__MODERATION__MUTE)),
                            (channel === null || channel === void 0 ? void 0 : channel.memberCount) > 2 && React__default.createElement(MenuItem, { onClick: function () {
                                    closeDropdown();
                                    window.dispatchEvent(new CustomEvent("sendbird.confirm", {
                                        detail: {
                                            confirm_type: "confirmBan",
                                            confirmed_message: "memberBanned",
                                            on_confirmed: function () {
                                                channel === null || channel === void 0 ? void 0 : channel.banUser(member, -1, '').then(function () {
                                                    refreshList();
                                                });
                                            }
                                        }
                                    }));
                                }, dataSbId: "channel_setting_member_context_menu_ban" }, stringSet.CHANNEL_SETTING__MODERATION__BAN))); } }));
                }
                : function () { return null; } })); }),
        React__default.createElement("div", { className: "sendbird-channel-settings-accordion__footer" },
            hasNext && (React__default.createElement(Button, { type: ButtonTypes.SECONDARY, size: ButtonSizes.SMALL, onClick: function () { return setShowAllMembers(true); } }, stringSet.CHANNEL_SETTING__MEMBERS__SEE_ALL_MEMBERS)),
            React__default.createElement(Button, { type: ButtonTypes.SECONDARY, size: ButtonSizes.SMALL, onClick: function () {
                    window.dispatchEvent(new CustomEvent("sendbird.addMemberToChannel", {
                        detail: {
                            channel_url: channel === null || channel === void 0 ? void 0 : channel.url
                        }
                    }));
                } }, stringSet.CHANNEL_SETTING__MEMBERS__INVITE_MEMBER)),
        showAllMembers && (React__default.createElement(MembersModal, { onCancel: function () {
                setShowAllMembers(false);
                refreshList();
            } }))));
};

export { MemberList as M };
//# sourceMappingURL=bundle-IrSSguGA.js.map
