'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _tslib = require('../../chunks/bundle-C1iXH_lz.js');
var React = require('react');
var index = require('../../chunks/bundle-ggWkCnWp.js');
var MessageInputWrapperView = require('../../chunks/bundle-mUanJx1a.js');
var Channel_context = require('../context.js');
var useSendbirdStateContext = require('../../useSendbirdStateContext.js');
require('@sendbird/chat/groupChannel');
require('../../utils/message/getOutgoingMessageState.js');
require('../../chunks/bundle-CbqhVtgy.js');
require('../../chunks/bundle-CRF-8eNm.js');
require('../../chunks/bundle-BYgb3hss.js');
require('../../chunks/bundle-CaxyE1uP.js');
require('../../GroupChannel/components/SuggestedMentionList.js');
require('../../chunks/bundle-kp5_YNxf.js');
require('../../chunks/bundle-d98ZY6cX.js');
require('../../ui/Icon.js');
require('../../chunks/bundle-DDsjylXE.js');
require('../../chunks/bundle-CUrtGuno.js');
require('../../ui/ImageRenderer.js');
require('../../chunks/bundle-CZ43TiD0.js');
require('../../chunks/bundle-CFgPLG7x.js');
require('../../chunks/bundle-DLNFkt38.js');
require('../../chunks/bundle-CYpA4YvV.js');
require('../../Message/hooks/useDirtyGetMentions.js');
require('../../ui/QuoteMessageInput.js');
require('../../chunks/bundle-fcSrqUpd.js');
require('../../VoicePlayer/useVoicePlayer.js');
require('../../chunks/bundle-kwY9bURo.js');
require('../../chunks/bundle-CBfbgiwa.js');
require('../../chunks/bundle-BV4UQzl0.js');
require('react-dom');
require('../../chunks/bundle-Ce_LIPHH.js');
require('../../ui/IconButton.js');
require('../../ui/Button.js');
require('@sendbird/uikit-tools');
require('../../withSendbird.js');
require('css-vars-ponyfill');
require('@sendbird/chat');
require('@sendbird/chat/openChannel');
require('../../chunks/bundle-CSp_Z9WK.js');
require('../../VoiceRecorder/useVoiceRecorder.js');
require('../../chunks/bundle-adVziAwN.js');
require('../../ui/PlaybackTime.js');
require('../../ui/ProgressBar.js');
require('../../ui/TextButton.js');
require('../../chunks/bundle-COLkgs4M.js');
require('../../ui/MessageInput.js');
require('../../chunks/bundle-Clj1obcq.js');
require('dompurify');
require('../../chunks/bundle-DsIHVOmg.js');
require('../../chunks/bundle-CRYm5FCe.js');
require('../../chunks/bundle-D44gLmng.js');
require('../../chunks/bundle-PJ_2lj5M.js');
require('../../chunks/bundle-oZU3raBc.js');
require('../../chunks/bundle-B_3UVRGD.js');
require('../../chunks/bundle-DYwqgFGE.js');
require('@sendbird/chat/message');
require('../../chunks/bundle-BUGsOchw.js');
require('../../chunks/bundle-CM_QjHPG.js');
require('../../chunks/bundle-DT6w7Uab.js');
require('../../chunks/bundle-BVg9ntoO.js');
require('../../chunks/bundle-AUSNBZEZ.js');
require('../../chunks/bundle-D-P1KjhS.js');
require('../../chunks/bundle-DbLPrtw4.js');
require('../../chunks/bundle-DAhXMboX.js');
require('../../chunks/bundle-HKXeZbAy.js');
require('../../chunks/bundle-DAx7HwSK.js');

var MessageInputWrapper = function (props) {
    var _a, _b;
    var config = useSendbirdStateContext.useSendbirdStateContext().config;
    var context = Channel_context.useChannelContext();
    var quoteMessage = context.quoteMessage, localMessages = context.localMessages, currentGroupChannel = context.currentGroupChannel, sendMessage = context.sendMessage, sendFileMessage = context.sendFileMessage, sendVoiceMessage = context.sendVoiceMessage, sendMultipleFilesMessage = context.sendMultipleFilesMessage;
    var lastMessage = currentGroupChannel === null || currentGroupChannel === void 0 ? void 0 : currentGroupChannel.lastMessage;
    var isLastMessageSuggestedRepliesEnabled = ((_a = config === null || config === void 0 ? void 0 : config.groupChannel) === null || _a === void 0 ? void 0 : _a.enableSuggestedReplies)
        && index.getSuggestedReplies(lastMessage).length > 0
        && (localMessages === null || localMessages === void 0 ? void 0 : localMessages.length) === 0;
    var disableMessageInput = props.disabled
        || isLastMessageSuggestedRepliesEnabled && !!((_b = lastMessage === null || lastMessage === void 0 ? void 0 : lastMessage.extendedMessagePayload) === null || _b === void 0 ? void 0 : _b['disable_chat_input']);
    return (React.createElement(MessageInputWrapperView.MessageInputWrapperView, _tslib.__assign({}, props, context, { disabled: disableMessageInput, currentChannel: currentGroupChannel, sendUserMessage: function (params) {
            return sendMessage({
                message: params.message,
                mentionTemplate: params.mentionedMessageTemplate,
                mentionedUsers: params.mentionedUsers,
                quoteMessage: quoteMessage !== null && quoteMessage !== void 0 ? quoteMessage : undefined,
            });
        }, sendFileMessage: function (params) {
            return sendFileMessage(params.file, quoteMessage !== null && quoteMessage !== void 0 ? quoteMessage : undefined);
        }, sendVoiceMessage: function (_a, duration) {
            var file = _a.file;
            return sendVoiceMessage(file, duration, quoteMessage !== null && quoteMessage !== void 0 ? quoteMessage : undefined);
        }, sendMultipleFilesMessage: function (_a) {
            var fileInfoList = _a.fileInfoList;
            return sendMultipleFilesMessage(fileInfoList.map(function (fileInfo) { return fileInfo.file; }), quoteMessage !== null && quoteMessage !== void 0 ? quoteMessage : undefined);
        } })));
};

exports.MessageInputWrapper = MessageInputWrapper;
exports.default = MessageInputWrapper;
//# sourceMappingURL=MessageInput.js.map
