'use strict';

var React = require('react');
var ChannelSettings_components_ChannelSettingsUI = require('./ChannelSettings/components/ChannelSettingsUI.js');
var ChannelSettings_context = require('./ChannelSettings/context.js');
require('./chunks/bundle-C1iXH_lz.js');
require('./useSendbirdStateContext.js');
require('./withSendbird.js');
require('./ChannelSettings/components/ChannelSettingsHeader.js');
require('./chunks/bundle-CRF-8eNm.js');
require('./chunks/bundle-BYgb3hss.js');
require('./chunks/bundle-CaxyE1uP.js');
require('./ui/Icon.js');
require('./chunks/bundle-DDsjylXE.js');
require('./ui/Header.js');
require('./chunks/bundle-d98ZY6cX.js');
require('./chunks/bundle-Ce_LIPHH.js');
require('./ui/TextButton.js');
require('./chunks/bundle-COLkgs4M.js');
require('./ui/IconButton.js');
require('./ui/PlaceHolder.js');
require('./ui/Loader.js');
require('./ChannelSettings/components/ChannelProfile.js');
require('./ui/ChannelAvatar.js');
require('./chunks/bundle-CUrtGuno.js');
require('./ui/ImageRenderer.js');
require('./chunks/bundle-CZ43TiD0.js');
require('./chunks/bundle-DM1x0Kmf.js');
require('./ChannelSettings/components/EditDetailsModal.js');
require('./chunks/bundle-BV4UQzl0.js');
require('./chunks/bundle-ggWkCnWp.js');
require('@sendbird/chat/groupChannel');
require('./utils/message/getOutgoingMessageState.js');
require('react-dom');
require('./ui/Button.js');
require('@sendbird/uikit-tools');
require('css-vars-ponyfill');
require('@sendbird/chat');
require('./chunks/bundle-CFgPLG7x.js');
require('@sendbird/chat/openChannel');
require('./chunks/bundle-kwY9bURo.js');
require('./chunks/bundle-CBfbgiwa.js');
require('./chunks/bundle-CSp_Z9WK.js');
require('./ui/Input.js');
require('./ChannelSettings/components/ModerationPanel.js');
require('./ui/Accordion.js');
require('./ui/AccordionGroup.js');
require('./ui/Badge.js');
require('./ui/Toggle.js');
require('./ui/ContextMenu.js');
require('./ui/SortByRow.js');
require('./ChannelSettings/components/UserListItem.js');
require('./chunks/bundle-B_3UVRGD.js');
require('./ui/MutedAvatarOverlay.js');
require('./ui/UserProfile.js');
require('./sendbirdSelectors.js');
require('./chunks/bundle-DbLPrtw4.js');
require('./ui/UserListItem.js');
require('./ui/Checkbox.js');
require('./chunks/bundle-Dk00HR_J.js');
require('./chunks/bundle-DYwqgFGE.js');
require('@sendbird/chat/message');
require('./chunks/bundle-XrvdkrhX.js');
require('./chunks/bundle-DDzXCEk7.js');
require('./ChannelSettings/components/LeaveChannel.js');
require('./ChannelSettings/components/UserPanel.js');

var ChannelSettings = function (props) {
    return (React.createElement(ChannelSettings_context.ChannelSettingsProvider, { overrideInviteUser: props === null || props === void 0 ? void 0 : props.overrideInviteUser, channelUrl: props.channelUrl, onCloseClick: props === null || props === void 0 ? void 0 : props.onCloseClick, onLeaveChannel: props === null || props === void 0 ? void 0 : props.onLeaveChannel, onChannelModified: props === null || props === void 0 ? void 0 : props.onChannelModified, onBeforeUpdateChannel: props === null || props === void 0 ? void 0 : props.onBeforeUpdateChannel, queries: props === null || props === void 0 ? void 0 : props.queries, className: props === null || props === void 0 ? void 0 : props.className, disableUserProfile: props === null || props === void 0 ? void 0 : props.disableUserProfile, renderUserProfile: props === null || props === void 0 ? void 0 : props.renderUserProfile },
        React.createElement(ChannelSettings_components_ChannelSettingsUI, { renderPlaceholderError: props === null || props === void 0 ? void 0 : props.renderPlaceholderError, renderChannelProfile: props === null || props === void 0 ? void 0 : props.renderChannelProfile, renderModerationPanel: props === null || props === void 0 ? void 0 : props.renderModerationPanel, renderLeaveChannel: props === null || props === void 0 ? void 0 : props.renderLeaveChannel })));
};

module.exports = ChannelSettings;
//# sourceMappingURL=ChannelSettings.js.map
