'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _tslib = require('../../chunks/bundle-C1iXH_lz.js');
var React = require('react');
var MessageInputWrapperView = require('../../chunks/bundle-mUanJx1a.js');
var GroupChannel_context = require('../context.js');
var uikitTools = require('@sendbird/uikit-tools');
var index = require('../../chunks/bundle-ggWkCnWp.js');
var useSendbirdStateContext = require('../../useSendbirdStateContext.js');
require('../../chunks/bundle-CbqhVtgy.js');
require('../../chunks/bundle-CRF-8eNm.js');
require('../../chunks/bundle-BYgb3hss.js');
require('../../chunks/bundle-CaxyE1uP.js');
require('./SuggestedMentionList.js');
require('../../chunks/bundle-kp5_YNxf.js');
require('../../chunks/bundle-d98ZY6cX.js');
require('../../ui/Icon.js');
require('../../chunks/bundle-DDsjylXE.js');
require('../../chunks/bundle-CUrtGuno.js');
require('../../ui/ImageRenderer.js');
require('../../chunks/bundle-CZ43TiD0.js');
require('../../chunks/bundle-CFgPLG7x.js');
require('../../chunks/bundle-DLNFkt38.js');
require('../../chunks/bundle-CYpA4YvV.js');
require('../../withSendbird.js');
require('../../Message/hooks/useDirtyGetMentions.js');
require('../../ui/QuoteMessageInput.js');
require('../../chunks/bundle-fcSrqUpd.js');
require('../../VoicePlayer/useVoicePlayer.js');
require('../../chunks/bundle-kwY9bURo.js');
require('../../chunks/bundle-CBfbgiwa.js');
require('../../chunks/bundle-BV4UQzl0.js');
require('react-dom');
require('../../chunks/bundle-Ce_LIPHH.js');
require('../../ui/IconButton.js');
require('../../ui/Button.js');
require('css-vars-ponyfill');
require('@sendbird/chat');
require('@sendbird/chat/openChannel');
require('@sendbird/chat/groupChannel');
require('../../chunks/bundle-CSp_Z9WK.js');
require('../../VoiceRecorder/useVoiceRecorder.js');
require('../../chunks/bundle-adVziAwN.js');
require('../../ui/PlaybackTime.js');
require('../../ui/ProgressBar.js');
require('../../ui/TextButton.js');
require('../../chunks/bundle-COLkgs4M.js');
require('../../ui/MessageInput.js');
require('../../chunks/bundle-Clj1obcq.js');
require('dompurify');
require('../../chunks/bundle-DsIHVOmg.js');
require('../../chunks/bundle-CRYm5FCe.js');
require('../../chunks/bundle-D44gLmng.js');
require('../../chunks/bundle-PJ_2lj5M.js');
require('../../chunks/bundle-oZU3raBc.js');
require('@sendbird/chat/message');
require('../../chunks/bundle-B_3UVRGD.js');
require('../../chunks/bundle-DAhXMboX.js');
require('../../chunks/bundle-HKXeZbAy.js');
require('../../chunks/bundle-Dk00HR_J.js');
require('../../chunks/bundle-DYwqgFGE.js');
require('../../chunks/bundle-XrvdkrhX.js');
require('../../chunks/bundle-D7WLPoqC.js');
require('../../chunks/bundle-DbLPrtw4.js');
require('../../chunks/bundle-BUGsOchw.js');
require('../../utils/message/getOutgoingMessageState.js');

var MessageInputWrapper = function (props) {
    var _a;
    var config = useSendbirdStateContext.useSendbirdStateContext().config;
    var context = GroupChannel_context.useGroupChannelContext();
    var messages = context.messages, currentChannel = context.currentChannel;
    var lastMessage = currentChannel === null || currentChannel === void 0 ? void 0 : currentChannel.lastMessage;
    var isLastMessageSuggestedRepliesEnabled = uikitTools.useIIFE(function () {
        var _a;
        if (!((_a = config === null || config === void 0 ? void 0 : config.groupChannel) === null || _a === void 0 ? void 0 : _a.enableSuggestedReplies))
            return false;
        if (index.getSuggestedReplies(lastMessage !== null && lastMessage !== void 0 ? lastMessage : undefined).length === 0)
            return false;
        var lastMessageInContext = messages[messages.length - 1];
        if (index.isSendableMessage(lastMessageInContext) && lastMessageInContext.sendingStatus !== 'succeeded')
            return false;
        return true;
    });
    var disableMessageInput = props.disabled
        || isLastMessageSuggestedRepliesEnabled && !!((_a = lastMessage === null || lastMessage === void 0 ? void 0 : lastMessage.extendedMessagePayload) === null || _a === void 0 ? void 0 : _a['disable_chat_input']);
    return (React.createElement(MessageInputWrapperView.MessageInputWrapperView, _tslib.__assign({}, props, context, { disabled: disableMessageInput })));
};

exports.VoiceMessageInputWrapper = MessageInputWrapperView.VoiceMessageInputWrapper;
exports.MessageInputWrapper = MessageInputWrapper;
exports.default = MessageInputWrapper;
//# sourceMappingURL=MessageInputWrapper.js.map
