'use strict';

var React = require('react');
var OpenChannelSettings_components_OpenChannelSettingsUI = require('./OpenChannelSettings/components/OpenChannelSettingsUI.js');
var OpenChannelSettings_context = require('./OpenChannelSettings/context.js');
require('./useSendbirdStateContext.js');
require('./withSendbird.js');
require('./chunks/bundle-C1iXH_lz.js');
require('./chunks/bundle-CRF-8eNm.js');
require('./chunks/bundle-BYgb3hss.js');
require('./chunks/bundle-CaxyE1uP.js');
require('./chunks/bundle-d98ZY6cX.js');
require('./ui/Icon.js');
require('./chunks/bundle-DDsjylXE.js');
require('./ui/PlaceHolder.js');
require('./ui/Loader.js');
require('./OpenChannelSettings/components/OperatorUI.js');
require('./OpenChannelSettings/components/OpenChannelProfile.js');
require('./ui/TextButton.js');
require('./chunks/bundle-COLkgs4M.js');
require('./ui/OpenChannelAvatar.js');
require('./chunks/bundle-CUrtGuno.js');
require('./ui/ImageRenderer.js');
require('./chunks/bundle-CZ43TiD0.js');
require('./chunks/bundle-DM1x0Kmf.js');
require('./OpenChannelSettings/components/EditDetailsModal.js');
require('./chunks/bundle-DbLPrtw4.js');
require('./chunks/bundle-BV4UQzl0.js');
require('./chunks/bundle-ggWkCnWp.js');
require('@sendbird/chat/groupChannel');
require('./utils/message/getOutgoingMessageState.js');
require('react-dom');
require('./chunks/bundle-Ce_LIPHH.js');
require('./ui/IconButton.js');
require('./ui/Button.js');
require('@sendbird/uikit-tools');
require('css-vars-ponyfill');
require('@sendbird/chat');
require('./chunks/bundle-CFgPLG7x.js');
require('@sendbird/chat/openChannel');
require('./chunks/bundle-kwY9bURo.js');
require('./chunks/bundle-CBfbgiwa.js');
require('./chunks/bundle-CSp_Z9WK.js');
require('./ui/Input.js');
require('./chunks/bundle-Cp5Qqfco.js');
require('./ui/ContextMenu.js');
require('./ui/SortByRow.js');
require('./chunks/bundle-B_3UVRGD.js');
require('./ui/AccordionGroup.js');
require('./ui/MutedAvatarOverlay.js');
require('./ui/UserProfile.js');
require('./sendbirdSelectors.js');
require('./ui/UserListItem.js');
require('./ui/Checkbox.js');
require('./ui/Accordion.js');

var OpenChannelSetting = function (props) {
    return (React.createElement(OpenChannelSettings_context.OpenChannelSettingsProvider, { channelUrl: props === null || props === void 0 ? void 0 : props.channelUrl, onCloseClick: props === null || props === void 0 ? void 0 : props.onCloseClick, onBeforeUpdateChannel: props === null || props === void 0 ? void 0 : props.onBeforeUpdateChannel, onChannelModified: props === null || props === void 0 ? void 0 : props.onChannelModified, onDeleteChannel: props === null || props === void 0 ? void 0 : props.onDeleteChannel, disableUserProfile: props === null || props === void 0 ? void 0 : props.disableUserProfile, renderUserProfile: props === null || props === void 0 ? void 0 : props.renderUserProfile },
        React.createElement(OpenChannelSettings_components_OpenChannelSettingsUI, { renderOperatorUI: props === null || props === void 0 ? void 0 : props.renderOperatorUI, renderParticipantList: props === null || props === void 0 ? void 0 : props.renderParticipantList })));
};

module.exports = OpenChannelSetting;
//# sourceMappingURL=OpenChannelSettings.js.map
