'use strict';

var React = require('react');
var Thread_context = require('./Thread/context.js');
var Thread_components_ThreadUI = require('./Thread/components/ThreadUI.js');
require('./chunks/bundle-DAx7HwSK.js');
require('./chunks/bundle-DbLPrtw4.js');
require('./chunks/bundle-DYwqgFGE.js');
require('./chunks/bundle-C1iXH_lz.js');
require('@sendbird/chat/message');
require('./utils/message/getOutgoingMessageState.js');
require('./chunks/bundle-CBfbgiwa.js');
require('./chunks/bundle-B_3UVRGD.js');
require('./useSendbirdStateContext.js');
require('./withSendbird.js');
require('./Thread/context/types.js');
require('@sendbird/chat');
require('./chunks/bundle-DT6w7Uab.js');
require('@sendbird/chat/groupChannel');
require('./chunks/bundle-CFgPLG7x.js');
require('./chunks/bundle-BVg9ntoO.js');
require('./chunks/bundle-CRF-8eNm.js');
require('./chunks/bundle-BYgb3hss.js');
require('./chunks/bundle-CaxyE1uP.js');
require('./chunks/bundle-BYTChesz.js');
require('./chunks/bundle-d98ZY6cX.js');
require('./Thread/components/ParentMessageInfo.js');
require('./chunks/bundle-CM_QjHPG.js');
require('./chunks/bundle-DtLms7VY.js');
require('./chunks/bundle-BV4UQzl0.js');
require('./chunks/bundle-ggWkCnWp.js');
require('./chunks/bundle-DDsjylXE.js');
require('react-dom');
require('./chunks/bundle-Ce_LIPHH.js');
require('./ui/IconButton.js');
require('./ui/Button.js');
require('./ui/Icon.js');
require('@sendbird/uikit-tools');
require('css-vars-ponyfill');
require('@sendbird/chat/openChannel');
require('./chunks/bundle-kwY9bURo.js');
require('./chunks/bundle-CSp_Z9WK.js');
require('./chunks/bundle-Fz8bb3aD.js');
require('./Thread/components/ParentMessageInfoItem.js');
require('./ui/ImageRenderer.js');
require('./ui/TextButton.js');
require('./chunks/bundle-COLkgs4M.js');
require('./ui/EmojiReactions.js');
require('./ui/ReactionBadge.js');
require('./ui/ReactionButton.js');
require('./chunks/bundle-i2g7ZRrX.js');
require('./ui/ContextMenu.js');
require('./ui/SortByRow.js');
require('./ui/BottomSheet.js');
require('./ui/UserListItem.js');
require('./chunks/bundle-CUrtGuno.js');
require('./chunks/bundle-CZ43TiD0.js');
require('./ui/MutedAvatarOverlay.js');
require('./ui/Checkbox.js');
require('./ui/UserProfile.js');
require('./sendbirdSelectors.js');
require('./ui/Tooltip.js');
require('./ui/TooltipWrapper.js');
require('./Message/context.js');
require('./chunks/bundle-BUGsOchw.js');
require('./ui/VoiceMessageItemBody.js');
require('./ui/ProgressBar.js');
require('./VoicePlayer/useVoicePlayer.js');
require('./ui/PlaybackTime.js');
require('./ui/Loader.js');
require('./chunks/bundle-Bi5JuZ95.js');
require('./chunks/bundle-PJ_2lj5M.js');
require('./ui/MentionLabel.js');
require('./ui/LinkLabel.js');
require('./chunks/bundle-BbIO8sMp.js');
require('./chunks/bundle-d_icBl7I.js');
require('./chunks/bundle-DXmUcWUo.js');
require('./chunks/bundle-CNh_xK0s.js');
require('./chunks/bundle-kp5_YNxf.js');
require('./chunks/bundle-DLNFkt38.js');
require('./chunks/bundle-CYpA4YvV.js');
require('./ui/MessageItemMenu.js');
require('./chunks/bundle-ODbgqlTB.js');
require('./ui/MessageItemReactionMenu.js');
require('./ui/MessageInput.js');
require('./chunks/bundle-Clj1obcq.js');
require('dompurify');
require('./chunks/bundle-DsIHVOmg.js');
require('./chunks/bundle-CRYm5FCe.js');
require('./chunks/bundle-D44gLmng.js');
require('./chunks/bundle-Cn2GBKcz.js');
require('./Message/hooks/useDirtyGetMentions.js');
require('./chunks/bundle-HKXeZbAy.js');
require('./Thread/components/ThreadHeader.js');
require('./ui/Header.js');
require('./Thread/components/ThreadList.js');
require('./Thread/components/ThreadListItem.js');
require('./ui/DateSeparator.js');
require('./chunks/bundle-DQcAMIkW.js');
require('./chunks/bundle-CYUwXUd-.js');
require('./chunks/bundle-C8zKC7Gk.js');
require('./ui/TextMessageItemBody.js');
require('./ui/OGMessageItemBody.js');
require('./ui/FileMessageItemBody.js');
require('./ui/ThumbnailMessageItemBody.js');
require('./chunks/bundle-fcSrqUpd.js');
require('./ui/UnknownMessageItemBody.js');
require('./Channel/utils/compareMessagesForGrouping.js');
require('date-fns');
require('./Thread/components/ThreadMessageInput.js');
require('./chunks/bundle-mUanJx1a.js');
require('./chunks/bundle-CbqhVtgy.js');
require('./GroupChannel/components/SuggestedMentionList.js');
require('./ui/QuoteMessageInput.js');
require('./VoiceRecorder/useVoiceRecorder.js');
require('./chunks/bundle-adVziAwN.js');
require('./chunks/bundle-oZU3raBc.js');
require('./GroupChannel/context.js');
require('./chunks/bundle-DAhXMboX.js');
require('./chunks/bundle-Dk00HR_J.js');
require('./chunks/bundle-XrvdkrhX.js');
require('./chunks/bundle-D7WLPoqC.js');
require('./Channel/hooks/useHandleUploadFiles.js');
require('./ui/PlaceHolder.js');

var Thread = function (props) {
    var 
    // props
    className = props.className, 
    // ThreadProviderProps
    channelUrl = props.channelUrl, message = props.message, onHeaderActionClick = props.onHeaderActionClick, onMoveToParentMessage = props.onMoveToParentMessage, isMultipleFilesMessageEnabled = props.isMultipleFilesMessageEnabled, 
    // onBeforeSend~~~Message
    onBeforeSendUserMessage = props.onBeforeSendUserMessage, onBeforeSendFileMessage = props.onBeforeSendFileMessage, onBeforeSendVoiceMessage = props.onBeforeSendVoiceMessage, onBeforeSendMultipleFilesMessage = props.onBeforeSendMultipleFilesMessage, 
    // ThreadUIProps
    renderHeader = props.renderHeader, renderParentMessageInfo = props.renderParentMessageInfo, renderMessage = props.renderMessage, renderMessageInput = props.renderMessageInput, renderCustomSeparator = props.renderCustomSeparator, renderParentMessageInfoPlaceholder = props.renderParentMessageInfoPlaceholder, renderThreadListPlaceHolder = props.renderThreadListPlaceHolder, renderFileUploadIcon = props.renderFileUploadIcon, renderVoiceMessageIcon = props.renderVoiceMessageIcon, renderSendMessageIcon = props.renderSendMessageIcon;
    return (React.createElement("div", { className: "sendbird-thread ".concat(className) },
        React.createElement(Thread_context.ThreadProvider, { channelUrl: channelUrl, message: message, onHeaderActionClick: onHeaderActionClick, onMoveToParentMessage: onMoveToParentMessage, onBeforeSendUserMessage: onBeforeSendUserMessage, onBeforeSendFileMessage: onBeforeSendFileMessage, onBeforeSendVoiceMessage: onBeforeSendVoiceMessage, onBeforeSendMultipleFilesMessage: onBeforeSendMultipleFilesMessage, isMultipleFilesMessageEnabled: isMultipleFilesMessageEnabled },
            React.createElement(Thread_components_ThreadUI, { renderHeader: renderHeader, renderParentMessageInfo: renderParentMessageInfo, renderMessage: renderMessage, renderMessageInput: renderMessageInput, renderCustomSeparator: renderCustomSeparator, renderParentMessageInfoPlaceholder: renderParentMessageInfoPlaceholder, renderThreadListPlaceHolder: renderThreadListPlaceHolder, renderFileUploadIcon: renderFileUploadIcon, renderVoiceMessageIcon: renderVoiceMessageIcon, renderSendMessageIcon: renderSendMessageIcon }))));
};

module.exports = Thread;
//# sourceMappingURL=Thread.js.map
