'use strict';

var React = require('react');
var ui_Button = require('../ui/Button.js');
var ui_IconButton = require('../ui/IconButton.js');
var ui_Icon = require('../ui/Icon.js');
var ui_ContextMenu = require('../ui/ContextMenu.js');
var ChannelSettings_components_UserListItem = require('../ChannelSettings/components/UserListItem.js');
var _tslib = require('./bundle-C1iXH_lz.js');
var SendbirdChat = require('@sendbird/chat');
var ui_Modal = require('./bundle-BV4UQzl0.js');
var ui_UserListItem = require('../ui/UserListItem.js');
var utils = require('./bundle-DDsjylXE.js');
var ChannelSettings_context = require('../ChannelSettings/context.js');
var useSendbirdStateContext = require('../useSendbirdStateContext.js');
var LocalizationContext = require('./bundle-CRF-8eNm.js');
var index = require('./bundle-Dk00HR_J.js');
var uuid = require('./bundle-CFgPLG7x.js');

function MembersModal(_a) {
    var _this = this;
    var _b;
    var onCancel = _a.onCancel;
    var _c = React.useState([]), members = _c[0], setMembers = _c[1];
    var _d = React.useState(null), memberQuery = _d[0], setMemberQuery = _d[1];
    var channel = ChannelSettings_context.useChannelSettingsContext().channel;
    var state = useSendbirdStateContext.useSendbirdStateContext();
    var currentUserId = (_b = state === null || state === void 0 ? void 0 : state.config) === null || _b === void 0 ? void 0 : _b.userId;
    var stringSet = React.useContext(LocalizationContext.LocalizationContext).stringSet;
    React.useEffect(function () {
        var memberListQuery = channel === null || channel === void 0 ? void 0 : channel.createMemberListQuery({
            limit: 20,
        });
        memberListQuery === null || memberListQuery === void 0 ? void 0 : memberListQuery.next().then(function (members) {
            setMembers(members);
        });
        setMemberQuery(memberListQuery !== null && memberListQuery !== void 0 ? memberListQuery : null);
    }, []);
    return (React.createElement("div", null,
        React.createElement(ui_Modal.Modal, { isFullScreenOnMobile: true, hideFooter: true, onCancel: function () { return onCancel(); }, onSubmit: utils.noop, titleText: stringSet.CHANNEL_SETTING__MEMBERS__SEE_ALL_MEMBERS },
            React.createElement("div", { className: "sendbird-more-members__popup-scroll", onScroll: index.useOnScrollPositionChangeDetector({
                    onReachedBottom: function () { return _tslib.__awaiter(_this, void 0, void 0, function () {
                        return _tslib.__generator(this, function (_a) {
                            if (memberQuery && memberQuery.hasNext) {
                                memberQuery.next().then(function (o) {
                                    setMembers(_tslib.__spreadArray(_tslib.__spreadArray([], members, true), o, true));
                                });
                            }
                            return [2 /*return*/];
                        });
                    }); },
                }) }, members.map(function (member) {
                return (React.createElement(ui_UserListItem, { user: member, key: member.userId, currentUser: currentUserId, action: function (_a) {
                        var parentRef = _a.parentRef, actionRef = _a.actionRef;
                        return (React.createElement(React.Fragment, null, (channel === null || channel === void 0 ? void 0 : channel.myRole) === 'operator' && currentUserId !== member.userId && (React.createElement(ui_ContextMenu.default, { menuTrigger: function (toggleDropdown) { return (React.createElement(ui_IconButton, { className: "sendbird-user-message__more__menu", width: "32px", height: "32px", onClick: function () {
                                    toggleDropdown();
                                } },
                                React.createElement(ui_Icon.default, { width: "24px", height: "24px", type: ui_Icon.IconTypes.MORE, fillColor: ui_Icon.IconColors.CONTENT_INVERSE }))); }, menuItems: function (closeDropdown) { return (React.createElement(ui_ContextMenu.MenuItems, { parentContainRef: parentRef, parentRef: actionRef, closeDropdown: closeDropdown, openLeft: true },
                                React.createElement(ui_ContextMenu.OperatorMenuItem, { channel: channel, user: member, disable: currentUserId === member.userId, onChange: function (_, member, isOperator) {
                                        var newMembers = _tslib.__spreadArray([], members, true);
                                        for (var _i = 0, newMembers_1 = newMembers; _i < newMembers_1.length; _i++) {
                                            var newMember = newMembers_1[_i];
                                            if (newMember.userId === member.userId) {
                                                newMember.role = isOperator ? SendbirdChat.Role.OPERATOR : SendbirdChat.Role.NONE;
                                            }
                                        }
                                        setMembers(newMembers);
                                        closeDropdown();
                                    }, onError: function () {
                                        // FIXME: handle error later
                                        closeDropdown();
                                    }, dataSbId: "channel_setting_member_context_menu_".concat((member.role !== 'operator') ? 'register_as_operator' : 'unregister_operator') }, member.role !== 'operator'
                                    ? stringSet.CHANNEL_SETTING__MODERATION__REGISTER_AS_OPERATOR
                                    : stringSet.CHANNEL_SETTING__MODERATION__UNREGISTER_OPERATOR),
                                // No muted members in broadcast channel
                                !(channel === null || channel === void 0 ? void 0 : channel.isBroadcast) && (React.createElement(ui_ContextMenu.MuteMenuItem, { channel: channel, user: member, onChange: function (_, member, isMuted) {
                                        var newMembers = _tslib.__spreadArray([], members, true);
                                        for (var _i = 0, newMembers_2 = newMembers; _i < newMembers_2.length; _i++) {
                                            var newMember = newMembers_2[_i];
                                            if (newMember.userId === member.userId) {
                                                newMember.isMuted = isMuted;
                                            }
                                        }
                                        setMembers(newMembers);
                                        closeDropdown();
                                    }, onError: function () {
                                        // FIXME: handle error later
                                        closeDropdown();
                                    }, dataSbId: "channel_setting_member_context_menu_".concat((member.isMuted) ? 'unmute' : 'mute') }, member.isMuted
                                    ? stringSet.CHANNEL_SETTING__MODERATION__UNMUTE
                                    : stringSet.CHANNEL_SETTING__MODERATION__MUTE)),
                                React.createElement(ui_ContextMenu.MenuItem, { onClick: function () {
                                        channel === null || channel === void 0 ? void 0 : channel.banUser(member, -1, '').then(function () {
                                            setMembers(members.filter(function (_a) {
                                                var userId = _a.userId;
                                                return userId !== member.userId;
                                            }));
                                        });
                                    }, dataSbId: "channel_setting_member_context_menu_ban" }, stringSet.CHANNEL_SETTING__MODERATION__BAN))); } }))));
                    } }));
            })))));
}

var MemberList = function () {
    var _a, _b, _c;
    var _d = React.useState([]), members = _d[0], setMembers = _d[1];
    var _e = React.useState(false), hasNext = _e[0], setHasNext = _e[1];
    var _f = React.useState(false), showAllMembers = _f[0], setShowAllMembers = _f[1];
    var _g = React.useState(false); _g[0]; _g[1];
    var state = useSendbirdStateContext.useSendbirdStateContext();
    var _h = ChannelSettings_context.useChannelSettingsContext(), channel = _h.channel, setChannelUpdateId = _h.setChannelUpdateId;
    var stringSet = React.useContext(LocalizationContext.LocalizationContext).stringSet;
    var sdk = (_b = (_a = state === null || state === void 0 ? void 0 : state.stores) === null || _a === void 0 ? void 0 : _a.sdkStore) === null || _b === void 0 ? void 0 : _b.sdk;
    var userId = (_c = state === null || state === void 0 ? void 0 : state.config) === null || _c === void 0 ? void 0 : _c.userId;
    React.useEffect(function () {
        if (!channel) {
            setMembers([]);
            return;
        }
        var memberUserListQuery = channel === null || channel === void 0 ? void 0 : channel.createMemberListQuery({ limit: 10 });
        memberUserListQuery.next().then(function (members) {
            setMembers(members);
            setHasNext(memberUserListQuery.hasNext);
        });
    }, [channel]);
    var refreshList = React.useCallback(function () {
        if (!channel) {
            setMembers([]);
            return;
        }
        var memberUserListQuery = channel === null || channel === void 0 ? void 0 : channel.createMemberListQuery({ limit: 10 });
        memberUserListQuery.next().then(function (members) {
            setMembers(members);
            setHasNext(memberUserListQuery.hasNext);
            setChannelUpdateId === null || setChannelUpdateId === void 0 ? void 0 : setChannelUpdateId(uuid.uuidv4());
        });
    }, [channel]);
    React.useEffect(function () {
        window.addEventListener('sendbird.refreshMemberList', refreshList);
        return function () {
            window.removeEventListener('sendbird.refreshMemberList', refreshList);
        };
    });
    return (React.createElement("div", { className: "sendbird-channel-settings-member-list sendbird-accordion" },
        members.map(function (member) { return (React.createElement(ChannelSettings_components_UserListItem, { key: member.userId, user: member, currentUser: sdk.currentUser.userId, action: ((channel === null || channel === void 0 ? void 0 : channel.myRole) === 'operator' && userId !== member.userId)
                ? function (_a) {
                    var actionRef = _a.actionRef, parentRef = _a.parentRef;
                    return (React.createElement(ui_ContextMenu.default, { menuTrigger: function (toggleDropdown) { return (React.createElement(ui_IconButton, { className: "sendbird-user-message__more__menu", width: "32px", height: "32px", onClick: toggleDropdown },
                            React.createElement(ui_Icon.default, { width: "24px", height: "24px", type: ui_Icon.IconTypes.MORE, fillColor: ui_Icon.IconColors.CONTENT_INVERSE }))); }, menuItems: function (closeDropdown) { return (React.createElement(ui_ContextMenu.MenuItems, { parentContainRef: parentRef, parentRef: actionRef, closeDropdown: closeDropdown, openLeft: true },
                            React.createElement(ui_ContextMenu.OperatorMenuItem, { channel: channel, user: member, onChange: function () {
                                    refreshList();
                                    closeDropdown();
                                }, onError: utils.noop, dataSbId: "channel_setting_member_context_menu_".concat((member.role !== 'operator') ? 'register_as_operator' : 'unregister_operator') }, member.role !== 'operator'
                                ? stringSet.CHANNEL_SETTING__MODERATION__REGISTER_AS_OPERATOR
                                : stringSet.CHANNEL_SETTING__MODERATION__UNREGISTER_OPERATOR),
                            // No muted members in broadcast channel
                            // Also can't mute in a one-to-one
                            !(channel === null || channel === void 0 ? void 0 : channel.isBroadcast) && (channel === null || channel === void 0 ? void 0 : channel.memberCount) > 2 && (React.createElement(ui_ContextMenu.MuteMenuItem, { channel: channel, user: member, onChange: function () {
                                    refreshList();
                                    closeDropdown();
                                }, onError: utils.noop, dataSbId: "channel_setting_member_context_menu_".concat(member.isMuted ? 'unmute' : 'mute') }, member.isMuted
                                ? stringSet.CHANNEL_SETTING__MODERATION__UNMUTE
                                : stringSet.CHANNEL_SETTING__MODERATION__MUTE)),
                            (channel === null || channel === void 0 ? void 0 : channel.memberCount) > 2 && React.createElement(ui_ContextMenu.MenuItem, { onClick: function () {
                                    closeDropdown();
                                    window.dispatchEvent(new CustomEvent("sendbird.confirm", {
                                        detail: {
                                            confirm_type: "confirmBan",
                                            confirmed_message: "memberBanned",
                                            on_confirmed: function () {
                                                channel === null || channel === void 0 ? void 0 : channel.banUser(member, -1, '').then(function () {
                                                    refreshList();
                                                });
                                            }
                                        }
                                    }));
                                }, dataSbId: "channel_setting_member_context_menu_ban" }, stringSet.CHANNEL_SETTING__MODERATION__BAN))); } }));
                }
                : function () { return null; } })); }),
        React.createElement("div", { className: "sendbird-channel-settings-accordion__footer" },
            hasNext && (React.createElement(ui_Button.default, { type: ui_Button.ButtonTypes.SECONDARY, size: ui_Button.ButtonSizes.SMALL, onClick: function () { return setShowAllMembers(true); } }, stringSet.CHANNEL_SETTING__MEMBERS__SEE_ALL_MEMBERS)),
            React.createElement(ui_Button.default, { type: ui_Button.ButtonTypes.SECONDARY, size: ui_Button.ButtonSizes.SMALL, onClick: function () {
                    window.dispatchEvent(new CustomEvent("sendbird.addMemberToChannel", {
                        detail: {
                            channel_url: channel === null || channel === void 0 ? void 0 : channel.url
                        }
                    }));
                } }, stringSet.CHANNEL_SETTING__MEMBERS__INVITE_MEMBER)),
        showAllMembers && (React.createElement(MembersModal, { onCancel: function () {
                setShowAllMembers(false);
                refreshList();
            } }))));
};

exports.MemberList = MemberList;
//# sourceMappingURL=bundle-DDzXCEk7.js.map
